Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: avalon-framework avalon-logkit

BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0


Name:           activeio
Summary:        ActiveIO Protocol Implementation Framework
Url:            http://activeio.codehaus.org/
Version:        2.0
Release:        alt2_3jpp5
Epoch:          0
License:        Apache Software License 2.0
Group:          Development/Java
Source0:        activeio-2.0-r118-src.tar.gz
# svn export -r 118 svn://svn.activeio.codehaus.org/activeio/trunk/activeio

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        activeio-2.0-jpp-depmap.xml
Patch0:         activeio-2.0-project_xml.patch
Patch1:         activeio-2.0-HowlJournal.patch
Patch2:         activeio-2.0-ChannelFactoryTest.patch
Patch3:         activeio-2.0-maven_xml.patch
Patch4:         activeio-2.0-SynchChannelTestSupport.patch
Patch5:         activeio-2.0-SynchToAsynchChannelAdapter.patch
Patch6:         activeio-2.0-SyncToAsyncChannel.patch
Patch7:         activeio-2.0-SyncChannelTestSupport.patch
# patch out g1_0 style addGBean - will not work with g1_0
Patch8:         activeio-2.0-StandardServiceStackGBean.patch

BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: junit
BuildRequires: maven-plugins >= 0:1.1
BuildRequires: maven-plugins-base
BuildRequires: maven-plugin-license
BuildRequires: maven-plugin-test
BuildRequires: maven-plugin-xdoc
BuildRequires: saxon
BuildRequires: saxon-scripts
BuildRequires: excalibur-avalon-framework
BuildRequires: excalibur-avalon-logkit
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-logging
BuildRequires: concurrent
BuildRequires: geronimo11-base
BuildRequires: geronimo-j2ee-1.4-apis
BuildRequires: howl-logger
BuildRequires: jxta
BuildRequires: log4j
BuildRequires: mx4j
BuildRequires: openorb
BuildRequires: jetty5
BuildRequires: p2psockets

Requires: jakarta-commons-logging
Requires: concurrent
Requires: geronimo11-base
Requires: howl-logger
Requires: mx4j
Requires: openorb
Requires: jetty5
Requires: p2psockets

%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
ActiveIO provides a high performance IO framework 
for implementing protocols.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}

chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done

# Req ibmaio
rm src/java/org/activeio/net/AIOAsyncChannelFactory.java
rm src/java/org/activeio/net/AIOAsyncChannel.java
rm src/java/org/activeio/net/AIOSyncChannelServer.java
rm src/test/org/activeio/net/AIOAsyncChannelTest.java


if [ ! -f %{SOURCE4} ]; then
export DEPCAT=$(pwd)/activeio-2.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > activeio-2.0-depmap.new.xml
fi

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav

rm src/test/org/activeio/ChannelFactoryTest.java

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven

maven -Dmaven.repo.remote=file:/usr/share/maven/repository \
      -Dmaven.home.local=$MAVEN_HOME_LOCAL \
      -Dmaven.junit.sysproperties=ipv4 \
      -Dipv4=java.net.preferIPv4Stack=true \
      jar:install javadoc:generate

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 target/%{name}-%{version}-SNAPSHOT.jar \
      $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%doc LICENSE.txt
%{_javadir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Wed Jun 03 2009 Igor Vlasenko <viy@altlinux.ru> 0:2.0-alt2_3jpp5
- test src/test/org/activeio/ChannelFactoryTest.java was too long idle

* Sun Feb 22 2009 Igor Vlasenko <viy@altlinux.ru> 0:2.0-alt1_3jpp5
- fixed build with maven 2.0.7

* Tue Dec 18 2007 Igor Vlasenko <viy@altlinux.ru> 0:2.0-alt1_3jpp1.7
- converted from JPackage by jppimport script

